Index: /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php	(revision 8961)
@@ -8,6 +8,6 @@
   ------------------------------------------------------------------------------
   Author     : Grum
-    email    : grum@grum.dnsalias.com
-    website  : http://photos.grum.dnsalias.com
+    email    : grum@piwigo.org
+    website  : http://photos.grum.fr
     PWG user : http://forum.phpwebgallery.net/profile.php?id=3706
 
Index: /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php	(revision 8961)
@@ -3,7 +3,7 @@
 /* -----------------------------------------------------------------------------
   class name     : GPCCore
-  class version  : 1.3.1
-  plugin version : 3.3.2
-  date           : 2010-10-20
+  class version  : 1.3.2
+  plugin version : 3.4.0
+  date           : 2011-01-28
   ------------------------------------------------------------------------------
   author: grum at piwigo.org
@@ -28,7 +28,12 @@
 |         |            |   extended description function if present
 |         |            |
-|         |            | * implement the getPiwigoSystemPath function
-|         |            |
-|         |            | * implement the rmDir function
+|         |            | * implement the getPiwigoSystemPath() function
+|         |            |
+|         |            | * implement the rmDir() function
+|         |            |
+| 1.3.2   | 2011/01/28 | * implement the addUI() function
+|         |            |
+|         |            | * implement getMinified() & setMinifiedState() functions
+|         |            |
 |         |            |
 |         |            |
@@ -47,4 +52,7 @@
     - static function addHeaderCSS
     - static function addHeaderJS
+    - static function addUI
+    - static function getMinified
+    - static function setMinifiedState
     - static function getUserLanguageDesc
     - static function getPiwigoSystemPath
@@ -58,4 +66,5 @@
 {
   static private $piwigoSystemPath;
+  static private $minified='.min';
 
   static public $pluginName = "GPCCore";
@@ -79,13 +88,14 @@
         Array('name' => "CommonPlugin", 'version' => "2.2.0"),
         Array('name' => "GPCAjax", 'version' => "3.0.0"),
-        Array('name' => "GPCCore", 'version' => "1.3.1"),
+        Array('name' => "GPCCategorySelector", 'version' => "1.0.1"),
+        Array('name' => "GPCCore", 'version' => "1.3.2"),
         Array('name' => "GPCCss", 'version' => "3.0.0"),
-        Array('name' => "GPCPagesNavigations", 'version' => "2.0.0"),
+        Array('name' => "GPCPagesNavigation", 'version' => "2.0.0"),
         Array('name' => "GPCPublicIntegration", 'version' => "2.0.0"),
-        Array('name' => "GPCRequestBuilder", 'version' => "1.1.0"),
+        Array('name' => "GPCRequestBuilder", 'version' => "1.1.2"),
         Array('name' => "GPCTables", 'version' => "1.5.0"),
         Array('name' => "GPCTabSheet", 'version' => "1.1.1"),
-        Array('name' => "GPCTranslate", 'version' => "2.1.0"),
-        Array('name' => "GPCUsersGroups", 'version' => "2.0.0"),
+        Array('name' => "GPCTranslate", 'version' => "2.1.1"),
+        Array('name' => "GPCUsersGroups", 'version' => "2.1.0")
       )
     );
@@ -365,4 +375,6 @@
   {
     global $template;
+    $dummy1=null;
+    $dummy2=null;
 
     foreach(self::$headerItems['css'] as $file)
@@ -373,7 +385,157 @@
     foreach(self::$headerItems['js'] as $file)
     {
-      $template->append('head_elements', '<script type="text/javascript" src="'.$file.'"></script>');
-    }
-  }
+      //$template->append('head_elements', '<script type="text/javascript" src="'.$file.'"></script>');
+      $template->block_html_head(null, '<script type="text/javascript" src="'.$file.'"></script>', $dummy1, $dummy2);
+    }
+  }
+
+  /**
+   * add a ui component ; css & js dependencies are managed
+   *
+   * @param Array $list : possibles values are
+   *                        - inputCheckbox
+   *                        - inputColorPicker
+   *                        - inputColorsFB
+   *                        - inputConsole
+   *                        - inputDotArea
+   *                        - inputList
+   *                        - inputNum
+   *                        - inputPosition
+   *                        - inputRadio
+   *                        - inputStatusBar
+   *                        - inputText
+   *                        - categorySelector
+   */
+  static public function addUI($list)
+  {
+    global $template;
+
+    if(is_string($list)) $list=explode(',', $list);
+    if(!is_array($list)) return(false);
+
+    if(defined('IN_ADMIN'))
+    {
+      $themeFile=GPC_PATH.'css/%s_'.$template->get_themeconf('name').'.css';
+    }
+    else
+    {
+      $themeFile='themes/'.$template->get_themeconf('name').'/css/GPC%s.css';
+    }
+
+    foreach($list as $ui)
+    {
+      switch($ui)
+      {
+        case 'googleTranslate':
+          self::addHeaderJS('google.jsapi', 'http://www.google.com/jsapi');
+          self::addHeaderJS('gpc.googleTranslate', 'plugins/GrumPluginClasses/js/google_translate'.self::$minified.'.js');
+        case 'categorySelector':
+          self::addHeaderCSS('gpc.categorySelector', GPC_PATH.'css/categorySelector.css');
+          self::addHeaderCSS('gpc.categorySelectorT', sprintf($themeFile, 'categorySelector'));
+          self::addHeaderJS('gpc.categorySelector', GPC_PATH.'js/ui.categorySelector'.self::$minified.'.js');
+          break;
+        case 'inputCheckbox':
+          self::addHeaderCSS('gpc.inputCheckbox', GPC_PATH.'css/inputCheckbox.css');
+          self::addHeaderJS('gpc.inputCheckbox', GPC_PATH.'js/ui.inputCheckbox'.self::$minified.'.js');
+          break;
+        case 'inputColorPicker':
+          self::addHeaderCSS('gpc.inputText', GPC_PATH.'css/inputText.css');
+          self::addHeaderCSS('gpc.inputNum', GPC_PATH.'css/inputNum.css');
+          self::addHeaderCSS('gpc.inputColorsFB', GPC_PATH.'css/inputColorsFB.css');
+          self::addHeaderCSS('gpc.inputDotArea', GPC_PATH.'css/inputDotArea.css');
+          self::addHeaderCSS('gpc.inputColorPicker', GPC_PATH.'css/inputColorPicker.css');
+          self::addHeaderCSS('gpc.inputTextT', sprintf($themeFile, 'inputText'));
+          self::addHeaderCSS('gpc.inputNumT', sprintf($themeFile, 'inputNum'));
+          self::addHeaderCSS('gpc.inputColorsFBT', sprintf($themeFile, 'inputColorsFB'));
+          self::addHeaderCSS('gpc.inputDotAreaT', sprintf($themeFile, 'inputDotArea'));
+          self::addHeaderCSS('gpc.inputColorPickerT', sprintf($themeFile, 'inputColorPicker'));
+          self::addHeaderJS('jquery.ui', 'themes/default/js/ui/packed/ui.core.packed.js');
+          self::addHeaderJS('jquery.ui.slider', 'themes/default/js/ui/packed/ui.slider.packed.js');
+          self::addHeaderJS('jquery.ui.draggable', 'themes/default/js/ui/packed/ui.draggable.packed.js');
+          self::addHeaderJS('jquery.ui.dialog', 'themes/default/js/ui/packed/ui.slider.dialog.js');
+          self::addHeaderJS('gpc.inputText', GPC_PATH.'js/ui.inputText'.self::$minified.'.js');
+          self::addHeaderJS('gpc.inputNum', GPC_PATH.'js/ui.inputNum'.self::$minified.'.js');
+          self::addHeaderJS('gpc.inputColorsFB', GPC_PATH.'js/ui.inputColorsFB'.self::$minified.'.js');
+          self::addHeaderJS('gpc.inputDotArea', GPC_PATH.'js/ui.inputDotArea'.self::$minified.'.js');
+          self::addHeaderJS('gpc.inputColorPicker', GPC_PATH.'js/ui.inputColorPicker'.self::$minified.'.js');
+          break;
+        case 'inputColorsFB':
+          self::addHeaderCSS('gpc.inputColorsFB', GPC_PATH.'css/inputColorsFB.css');
+          self::addHeaderCSS('gpc.inputColorsFBT', sprintf($themeFile, 'inputColorsFB'));
+          self::addHeaderJS('gpc.inputColorsFB', GPC_PATH.'js/ui.inputColorsFB'.self::$minified.'.js');
+          break;
+        case 'inputConsole':
+          self::addHeaderCSS('gpc.inputConsole', GPC_PATH.'css/inputConsole.css');
+          self::addHeaderCSS('gpc.inputConsoleT', sprintf($themeFile, 'inputConsole'));
+          self::addHeaderJS('gpc.inputConsole', GPC_PATH.'js/ui.inputConsole'.self::$minified.'.js');
+          break;
+        case 'inputDotArea':
+          self::addHeaderCSS('gpc.inputDotArea', GPC_PATH.'css/inputDotArea.css');
+          self::addHeaderCSS('gpc.inputDotAreaT', sprintf($themeFile, 'inputDotArea'));
+          self::addHeaderJS('gpc.inputDotArea', GPC_PATH.'js/ui.inputDotArea'.self::$minified.'.js');
+          break;
+        case 'inputList':
+          self::addHeaderCSS('gpc.inputList', GPC_PATH.'css/inputList.css');
+          self::addHeaderCSS('gpc.inputListT', sprintf($themeFile, 'inputList'));
+          self::addHeaderJS('gpc.inputList', GPC_PATH.'js/ui.inputList'.self::$minified.'.js');
+          break;
+        case 'inputNum':
+          self::addHeaderCSS('gpc.inputNum', GPC_PATH.'css/inputNum.css');
+          self::addHeaderCSS('gpc.inputNumT', sprintf($themeFile, 'inputNum'));
+          self::addHeaderJS('jquery.ui', 'themes/default/js/ui/packed/ui.core.packed.js');
+          self::addHeaderJS('jquery.ui.slider', 'themes/default/js/ui/packed/ui.slider.packed.js');
+          self::addHeaderJS('gpc.inputNum', GPC_PATH.'js/ui.inputNum'.self::$minified.'.js');
+          break;
+        case 'inputPosition':
+          self::addHeaderCSS('gpc.inputPosition', GPC_PATH.'css/inputPosition.css');
+          self::addHeaderCSS('gpc.inputPositionT', sprintf($themeFile, 'inputPosition'));
+          self::addHeaderJS('gpc.inputPosition', GPC_PATH.'js/ui.inputPosition'.self::$minified.'.js');
+          break;
+        case 'inputRadio':
+          self::addHeaderJS('gpc.inputRadio', GPC_PATH.'js/ui.inputRadio'.self::$minified.'.js');
+          break;
+        case 'inputStatusBar':
+          self::addHeaderCSS('gpc.inputStatusBar', GPC_PATH.'css/inputStatusBar.css');
+          self::addHeaderCSS('gpc.inputStatusBarT', sprintf($themeFile, 'inputStatusBar'));
+          self::addHeaderJS('gpc.inputStatusBar', GPC_PATH.'js/ui.inputStatusBar'.self::$minified.'.js');
+          break;
+        case 'inputText':
+          self::addHeaderCSS('gpc.inputText', GPC_PATH.'css/inputText.css');
+          self::addHeaderCSS('gpc.inputTextT', sprintf($themeFile, 'inputText'));
+          self::addHeaderJS('gpc.inputText', GPC_PATH.'js/ui.inputText'.self::$minified.'.js');
+          break;
+      }
+    }
+  }
+
+  /**
+   * return the minified value
+   *
+   * @return String
+   */
+  static public function getMinified()
+  {
+    return(self::$minified);
+  }
+
+  /**
+   * set the minified state
+   *
+   * @param Bool $state
+   * @return Bool
+   */
+  static public function setMinifiedState($state)
+  {
+    if($state)
+    {
+      self::$minified='.min';
+    }
+    else
+    {
+      self::$minified='';
+    }
+    return(self::$minified!='');
+  }
+
 
   /**
Index: /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 8961)
@@ -2,6 +2,6 @@
 /* -----------------------------------------------------------------------------
   class name: GCPRequestBuilder
-  class version  : 1.1.1
-  plugin version : 3.3.2
+  class version  : 1.1.2
+  plugin version : 3.3.3
   date           : 2010-09-08
 
@@ -75,6 +75,7 @@
 |         |            | * fix bug on user level access to picture
 |         |            |
-|         |            |
-|         |            |
+| 1.1.2   | 2010/11/01 | * mantis bug:1984
+|         |            |   . RBuilder returns an error message when one picture
+|         |            |     have multiple categories
 |         |            |
 |         |            |
@@ -522,5 +523,5 @@
     GPCCore::addHeaderJS('gpc.interface', 'plugins/'.$baseName.'external/interface/interface.js');
     GPCCore::addHeaderJS('gpc.inestedsortable', 'plugins/'.$baseName.'external/inestedsortable.pack.js');
-    GPCCore::addHeaderJS('gpc.rbCriteriaBuilder', 'plugins/'.$baseName.'rbCriteriaBuilder.packed.js');
+    GPCCore::addHeaderJS('gpc.rbCriteriaBuilder', 'plugins/'.$baseName.'rbCriteriaBuilder'.GPCCore::getMinified().'.js');
 
     $template->append('head_elements',
@@ -829,8 +830,8 @@
       'SELECT' => Array(
         'RB_PIT' => "pit.id AS imageId, pit.name AS imageName, pit.path AS imagePath", // from the piwigo's image table
-        'RB_PIC' => "GROUP_CONCAT(DISTINCT pic.category_id SEPARATOR ',') AS imageCategoriesId",     // from the piwigo's image_category table
-        'RB_PCT' => "GROUP_CONCAT(DISTINCT CASE WHEN pct.name IS NULL THEN '' ELSE pct.name END SEPARATOR '#sep#') AS imageCategoriesNames,
-                     GROUP_CONCAT(DISTINCT CASE WHEN pct.permalink IS NULL THEN '' ELSE pct.permalink END SEPARATOR '#sep#') AS imageCategoriesPLink,
-                     GROUP_CONCAT(DISTINCT CASE WHEN pct.dir IS NULL THEN 'V' ELSE 'P' END) AS imageCategoriesDir",   //from the piwigo's categories table
+        'RB_PIC' => "GROUP_CONCAT( pic.category_id SEPARATOR ',') AS imageCategoriesId",     // from the piwigo's image_category table
+        'RB_PCT' => "GROUP_CONCAT( CASE WHEN pct.name IS NULL THEN '' ELSE pct.name END SEPARATOR '#sep#') AS imageCategoriesNames,
+                     GROUP_CONCAT( CASE WHEN pct.permalink IS NULL THEN '' ELSE pct.permalink END SEPARATOR '#sep#') AS imageCategoriesPLink,
+                     GROUP_CONCAT( CASE WHEN pct.dir IS NULL THEN 'V' ELSE 'P' END) AS imageCategoriesDir",   //from the piwigo's categories table
       ),
       'FROM' => Array(
@@ -1374,4 +1375,10 @@
     $filter=array_flip($filter);
 
+    GPCCore::addHeaderJS('jquery.ui', 'themes/default/js/ui/packed/ui.core.packed.js');
+    GPCCore::addHeaderJS('jquery.ui.dialog', 'themes/default/js/ui/packed/ui.dialog.packed.js');
+    GPCCore::addHeaderJS('gpc.pagesNavigator', 'plugins/'.$baseName.'/js/pagesNavigator'.GPCCore::getMinified().'.js');
+    GPCCore::addHeaderJS('gpc.rbSearch', 'plugins/'.$baseName.'/js/rbSearch'.GPCCore::getMinified().'.js');
+
+
     $template->set_filename('gpc_search_page',
                 dirname(dirname(__FILE__)).'/templates/GPCRequestBuilder_search.tpl');
Index: /extensions/GrumPluginClasses/classes/GPCTranslate.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCTranslate.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/GPCTranslate.class.inc.php	(revision 8961)
@@ -3,12 +3,11 @@
 /* -----------------------------------------------------------------------------
   class name     : GPCTranslate
-  class version  : 2.1.0
-  plugin version : 3.0.0
-  date           : 2010-03-31
+  class version  : 2.1.1
+  plugin version : 3.4.0
+  date           : 2011-01-28
   ------------------------------------------------------------------------------
   author: grum at piwigo.org
   << May the Little SpaceFrog be with you >>
   ------------------------------------------------------------------------------
-
 
   ------------------------------------------------------------------------------
@@ -19,17 +18,16 @@
 | 2.1.0   | 2010/03/31 | * update class & functions names
 |         |            |
+| 2.1.1   | 2011/01/09 | * fixbug on js loading
 |         |            |
-|         |            |
+|         |            | * use GPCCore::addUI function (the class is kept for
+|         |            |   compatibility with older plugins)
 |         |            |
 |         |            |
 
   ------------------------------------------------------------------------------
-
-
    class call API in HTML header, and provide a .js file manage API call
         >>  http://code.google.com/apis/ajaxlanguage/
 
     - constructor
-
    ---------------------------------------------------------------------- */
 class GPCTranslate
@@ -37,18 +35,6 @@
   public function __construct()
   {
-    add_event_handler('loc_end_page_header', array(&$this, 'loadJS'));
+    GPCCore::addUI('googleTranslate');
   }
-
-  public function loadJS()
-  {
-    global $template;
-
-    $googleload='
-<script type="text/javascript" src="http://www.google.com/jsapi"></script>
-<script type="text/javascript" src="plugins/'.basename(dirname(__FILE__)).'/google_translate.js"></script>';
-
-    $template->append('head_elements', $googleload);
-  }
-
 } //class
 
Index: /extensions/GrumPluginClasses/classes/GPCUsersGroups.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCUsersGroups.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/GPCUsersGroups.class.inc.php	(revision 8961)
@@ -3,6 +3,6 @@
 /* -----------------------------------------------------------------------------
   class name: GPCAllowedAccess, GPCGroups, GPCUsers
-  class version  : 2.0.0
-  plugin version : 3.0.0
+  class version  : 2.1.0
+  plugin version : 3.4.0
   date           : 2010-03-30
   ------------------------------------------------------------------------------
@@ -14,14 +14,12 @@
   groups and users classes extends GPCAllowedAccess classes
 
-    - constructor GPCAllowedAccess($alloweds="")
-    - constructor groups($alloweds="")
-    - constructor users($alloweds="")
+    - constructor GPCAllowedAccess($alloweds = array(), $accessMode='a')
+    - constructor groups($alloweds = array(), $accessMode='a')
+    - constructor users($alloweds = array(), $accessMode='a')
     - (public) function getList()
     - (public) function setAllowed($id, $allowed)
-    - (public) function setAlloweds()
-    - (public) function getAlloweds($return_type)
+    - (public) function setAlloweds($idList, $allowed)
+    - (public) function getAlloweds()
     - (public) function isAllowed($id)
-    - (public) function htmlView($sep=", ", $empty="")
-    - (public) function htmlForm($basename)
     - (private) function initList()
 
@@ -34,4 +32,8 @@
 |         |            | * update classes & functions names
 |         |            |
+| 2.1.0   | 2011/01/15 | * remove html function
+|         |            |
+|         |            | * implement accessMode
+|         |            |
 |         |            |
 
@@ -39,90 +41,105 @@
 class GPCAllowedAccess
 {
-  public $access_list;
-
-  /*
-    constructor initialize the groups_getListgetListlist
-  */
-  public function __construct($alloweds = "")
+  protected $accessList;
+  protected $accessMode='a'; // 'a' : allowed, 'n' : not allowed
+
+  /**
+   * constructor initialize default values
+   *
+   * @param Array $alloweds  : list of items
+   *        String $alloweds : list of items (separator : '/')
+   *
+   * @param String $accessMode : 'a' = access is allowed by default for all values, $allowed param is a list of not allowed values
+   *                             'n' = access is not allowed by default for all values, $allowed param is a list of allowed values
+   *                             priority is given to the $allowed value
+   */
+  public function __construct($alloweds = array(), $accessMode='a')
   {
     $this->initList();
-    $this->setAlloweds($alloweds);
+    $this->setAlloweds($alloweds, $accessMode=='n');
   }
 
   public function __destruct()
   {
-    unset($this->access_list);
-  }
-
-  /*
-    initialize the groups list
-  */
+    unset($this->accessList);
+  }
+
+  /**
+   * destroy the groups list
+   */
   protected function initList()
   {
-    $this->access_list=array();
-  }
-
-  /*
-    returns list (as an array)
-  */
+    $this->accessList=array();
+  }
+
+  /**
+   * returns list of items (as an array)
+   * each array item is an array :
+   *  'id'      : (String) id of item
+   *  'name'    : (String) name of item
+   *  'allowed' : (Bool)   access is allowed or not
+   *
+   * @return Array
+   */
   function getList()
   {
-    return($this->access_list);
-  }
-
-  /*
-    set element an allowed state
-  */
+    return($this->accessList);
+  }
+
+  /**
+   * set allowed value for an item
+   *
+   * @param String $id : id of item
+   * @param Bool $allowed : access allowed or not
+   */
   function setAllowed($id, $allowed)
   {
-    if(isset($this->access_list[$id]))
-    {
-      $this->access_list[$id]['allowed']=$allowed;
-    }
-  }
-
-  /*
-    set a group enabled/disabled state
-  */
-  function setState($id, $enabled)
-  {
-    if(isset($this->access_list[$id]))
-    {
-      $this->access_list[$id]['enabled']=$enabled;
-    }
-  }
-
-  /*
-    set alloweds list
-    $list is string of id, separated with "/"
-  */
-  function setAlloweds($list)
-  {
-    $alloweds=explode("/", $list);
-    $alloweds=array_flip($alloweds);
-    foreach($this->access_list as $key => $val)
-    {
-      if(isset($alloweds[$key]))
+    if(isset($this->accessList[$id]))
+    {
+      $this->accessList[$id]['allowed']=$allowed;
+    }
+  }
+
+
+  /**
+   * set alloweds items (can be given as an array or a string with separator '/')
+   * according to the
+   *
+   * @param Array $idList  : list of items to set
+   * @param String $idList
+   * @param Bool $allowed : access allowed or not
+   */
+  function setAlloweds($idList, $allowed)
+  {
+    if(!is_array($idList)) $idList=explode("/", $idList);
+
+    $idList=array_flip($idList);
+
+    foreach($this->accessList as $key => $val)
+    {
+      if(isset($idList[$key]))
       {
-        $this->access_list[$key]['allowed']=true;
+        $this->accessList[$key]['allowed']=$allowed;
       }
       else
       {
-        $this->access_list[$key]['allowed']=false;
+        $this->accessList[$key]['allowed']=!$allowed;
       }
     }
   }
 
-  /*
-    get alloweds list
-    return a string of groups, separated with "/"
-  */
-  function getAlloweds($return_type = 'name')
-  {
-    $returned="";
-    foreach($this->access_list as $key => $val)
-    {
-      if($val['allowed'])
-      { $returned.=$val[$return_type]."/"; }
+
+  /**
+   * return list of alloweds items
+   *
+   * @return Array
+   */
+  function getAlloweds()
+  {
+    $returned=Array();
+
+    foreach($this->accessList as $key => $val)
+    {
+      if($val['allowed']) $returned[]=$val;
     }
     return($returned);
@@ -130,100 +147,22 @@
 
 
-  /*
-    returns true if is allowed
-  */
+  /**
+   * returns true if is allowed
+   *
+   * @param String $id : item id
+   * @retrun Bool
+   */
   function isAllowed($id)
   {
-    if(isset($this->access_list[$id]))
-    { return($this->access_list[$id]['allowed']); }
+    if(isset($this->accessList[$id]))
+    {
+      return($this->accessList[$id]['allowed']);
+    }
     else
-    { return(false); }
-  }
-
-  /*
-    returns true if all or one is allowed
-      ids is an array
-  */
-  function areAllowed($ids, $all=false)
-  {
-    foreach($ids as $val)
-    {
-      if($all)
-      {
-        if(!$this->isAllowed($val))
-        {
-          return(false);
-        }
-      }
-      else
-      {
-        if($this->isAllowed($val))
-        {
-          return(true);
-        }
-      }
-    }
-    return(false);
-  }
-
-  /*
-    returns an HTML list with label rather than id
-  */
-  function htmlView($sep=", ", $empty="")
-  {
-    $returned="";
-    foreach($this->access_list as $key => $val)
-    {
-      if($val['allowed'])
-      {
-        if($returned!="")
-        {
-          $returned.=$sep;
-        }
-        $returned.=$val['name'];
-      }
-    }
-    if($returned=="")
-    {
-      $returned=$empty;
-    }
-    return($returned);
-  }
-  /*
-    returns a generic HTML form to manage the groups access
-  */
-  function htmlForm($basename)
-  {
-    /*
-    <!-- BEGIN allowed_group_row -->
-    <label><input type="checkbox" name="fmypolls_att_allowed_groups_{allowed_group_row.ID}" {allowed_group_row.CHECKED}/>&nbsp;{allowed_group_row.NAME}</label>
-    <!-- END allowed_group_row -->
-    */
-    $text='';
-    foreach($this->access_list as $key => $val)
-    {
-      if($val['allowed'])
-      {
-        $checked=' checked';
-      }
-      else
-      {
-        $checked='';
-      }
-
-      if($val['enabled'])
-      {
-        $enabled='';
-      }
-      else
-      {
-        $enabled=' disabled';
-      }
-
-      $text.='<label><input type="checkbox" name="'.$basename.$val['id'].'" '.$checked.$enabled.'/>
-          &nbsp;'.$val['name'].'</label>&nbsp;';
-    }
-    return($text);
-  }
+    {
+      return($this->accessMode=='a');
+    }
+  }
+
 } //GPCAllowedAccess
 
@@ -235,16 +174,18 @@
 
 
-/* ----------------------------------------------------------------------
-   this class provides base functions to manage groups access
-    initList redefined to initialize access_list from database GROUPS
-   ---------------------------------------------------------------------- */
+/**
+ * ----------------------------------------------------------------------------
+ *  this class provides base functions to manage groups access
+ *  initList redefined to initialize accessList from database GROUPS
+ * ----------------------------------------------------------------------------
+ */
 class GPCGroups extends GPCAllowedAccess
 {
-  /*
-    initialize the groups list
-  */
+  /**
+   * initialize the groups list
+   */
   protected  function initList()
   {
-    $this->access_list=array();
+    $this->accessList=array();
     $sql="SELECT id, name FROM ".GROUPS_TABLE." ORDER BY name";
     $result=pwg_query($sql);
@@ -253,9 +194,9 @@
       while($row=pwg_db_fetch_assoc($result))
       {
-        $this->access_list[$row['id']] =
-                   array('id' => $row['id'],
-                         'name' => $row['name'],
-                         'allowed' => false,
-                         'enabled' => true);
+        $this->accessList[$row['id']]=array(
+            'id' => $row['id'],
+            'name' => $row['name'],
+            'allowed' => ($this->accessMode=='a')
+          );
       }
     }
@@ -270,33 +211,26 @@
 
 
-/* -----------------------------------------------------------------------------
-   this class provides base functions to manage users access
------------------------------------------------------------------------------ */
+/**
+ * ----------------------------------------------------------------------------
+ *  this class provides base functions to manage users access
+ *  initList redefined to initialize accessList from piwigo's predefined values
+ * ----------------------------------------------------------------------------
+ */
 class GPCUsers extends GPCAllowedAccess
 {
-  /*
-    constructor
-  */
-  public function __construct($alloweds = "")
-  {
-    parent::__construct($alloweds);
-    $this->setState('admin', false);
-    $this->setAllowed('admin', true);
-  }
-
-  /*
-    initialize the groups list
-  */
+  /**
+   * initialize the users list
+   */
   protected function initList()
   {
-    $users_list = array('guest', 'generic', 'normal', 'webmaster', 'admin');
-    $this->access_list=array();
-    foreach($users_list as $val)
-    {
-      $this->access_list[$val] =
-                  array('id' => $val,
-                        'name' => l10n('user_status_'.$val),
-                        'allowed' => false,
-                        'enabled' => true);
+    $usersList = array('guest', 'generic', 'normal', 'webmaster', 'admin');
+    $this->accessList=array();
+    foreach($usersList as $val)
+    {
+      $this->accessList[$val]=array(
+          'id' => $val,
+          'name' => l10n('user_status_'.$val),
+          'allowed' => ($this->accessMode=='a')
+        );
     }
   }
Index: /extensions/GrumPluginClasses/classes/genericjs.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/genericjs.class.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/classes/genericjs.class.inc.php	(revision 8961)
@@ -1,41 +1,7 @@
 <?php
-
-/* -----------------------------------------------------------------------------
-  class name: genericjs
-  class version: 2.0
-  date: 2008-07-20
-  ------------------------------------------------------------------------------
-  author: grum at grum.dnsalias.com
-  << May the Little SpaceFrog be with you >>
-  ------------------------------------------------------------------------------
-
-   this classes provides base functions to add genericjs.js file into html page
-
-   > see genericjs.js file to know javascript functions added
-
-    - constructor genericjs()
-   ---------------------------------------------------------------------- */
-
-
-class genericjs
-{
-  function genericjs()
-  {
-    add_event_handler('loc_end_page_header', array(&$this, 'load_JS'));
-  }
-
-  function load_JS()
-  {
-    global $template;
-
-    $name='plugins/'.basename(dirname(dirname(__FILE__))).'/js/genericjs.js';
-
-    $template->append('head_elements', '<script src="'.$name.'" type="text/javascript"></script>');
-
-  }
-
-} //class
-
-$genericjs=new genericjs();
-
+/*
+ * dummy file to avoid compatibility problem with older plugin.
+ *
+ * this file have to be removed on the next release.
+ */
 ?>
Index: /extensions/GrumPluginClasses/gpc_version.inc.php
===================================================================
--- /extensions/GrumPluginClasses/gpc_version.inc.php	(revision 8960)
+++ /extensions/GrumPluginClasses/gpc_version.inc.php	(revision 8961)
@@ -15,5 +15,5 @@
   if(!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-  if(!defined('GPC_VERSION')) define('GPC_VERSION',  '3.3.4');
-  if(!defined('GPC_VERSION2')) define('GPC_VERSION2', '03.03.04');
+  if(!defined('GPC_VERSION')) define('GPC_VERSION',  '3.4.0');
+  if(!defined('GPC_VERSION2')) define('GPC_VERSION2', '03.04.00');
 ?>
Index: /extensions/GrumPluginClasses/js/google_translate.js
===================================================================
--- /extensions/GrumPluginClasses/js/google_translate.js	(revision 8960)
+++ /extensions/GrumPluginClasses/js/google_translate.js	(revision 8961)
@@ -1,6 +1,6 @@
 /* -----------------------------------------------------------------------------
   file: google_translate.js
-  file version: 2.0.0
-  date: 2008-05-25
+  file version: 2.1.0
+  date: 2011-01-09
   ------------------------------------------------------------------------------
   author: grum at piwigo.org
@@ -12,4 +12,5 @@
   HISTORY VERSION
   v2.0.0  +
+  v2.1.0  + add googleTranslate function with callback parameter
   --------------------------------------------------------------------------- */
 
@@ -17,4 +18,5 @@
 
   var global_google_translate_plugin_objdest;
+  var global_google_translate_plugin_callback;
   var global_google_translate_plugin_objproperty;
 
@@ -40,2 +42,17 @@
     }
   }
+
+  function googleTranslate(text, pfrom, pto, callback)
+  {
+    global_google_translate_plugin_callback=callback;
+    google.language.translate(text, pfrom, pto, googleTranslateDo);
+  }
+
+  function googleTranslateDo(result)
+  {
+    if (!result.error)
+    {
+      global_google_translate_plugin_callback(result.translation);
+    }
+  }
+
